//% color="#4169E1" iconWidth=50 iconHeight=40
namespace scd4xco2{

    //% block="Carbon dioxide sensor initialization until successful I2C mode address 0x62" blockType="command" 
    export function init(parameter: any, block: any) {

        Generator.addInclude("DFRobot_SCD4XInit", "#include <DFRobot_SCD4X.h>");
        
        Generator.addObject("DFRobot_SCD4XInit","DFRobot_SCD4X",`SCD4X(&Wire, 0x62);`);

        Generator.addSetup(`DFRobot_SCD4XInit`,   `while(!SCD4X.begin()){};
  SCD4X.setTempComp(4.0);
  SCD4X.setSensorAltitude(540);
  SCD4X.enablePeriodMeasure(SCD4X_START_PERIODIC_MEASURE);`);
    }


    //% block="Does the carbon dioxide sensor have data?" blockType="boolean"
    export function available(parameter: any, block: any) { 
        Generator.addCode( [`SCD4X.getDataReadyStatus()`,Generator.ORDER_UNARY_POSTFIX]);
   
   }

    //% block="Read the data once and save it and get the result" blockType="command"
    export function readdata(parameter: any, block: any) { 
        
        Generator.addCode(`DFRobot_SCD4X::sSensorMeasurement_t data;
SCD4X.readMeasurement(&data);`);
   
   }

    //% block="Fetch [DAT] data from result" blockType="reporter"
    //% DAT.shadow="dropdown"   DAT.options="DAT"
    export function getdata(parameter: any, block: any) { 
        let dat = parameter.DAT.code;
        Generator.addCode( [`${dat}`,Generator.ORDER_UNARY_POSTFIX]);
   
   } 
}