//% color="#4169E1" iconWidth=50 iconHeight=40
namespace scd4xco2{

    //% block="Carbon dioxide sensor initialization until successful I2C mode address 0x62" blockType="command" 
    export function init(parameter: any, block: any) {

        Generator.addImport("from DFRobot_SCD4X import *");
        Generator.addCode(`scd4xSensor = DFRobot_SCD4X()
while (not scd4xSensor.begin):
    print ('Please check that the device is properly connected')
    time.sleep(3)
scd4xSensor.enable_period_measure(SCD4X_STOP_PERIODIC_MEASURE)
scd4xSensor.set_temp_comp(4.0)
scd4xSensor.set_sensor_altitude(300)
scd4xSensor.enable_period_measure(SCD4X_START_PERIODIC_MEASURE)
`);
   
    }


    //% block="Does the carbon dioxide sensor have data?" blockType="boolean"
    export function available(parameter: any, block: any) { 
        Generator.addCode( [`scd4xSensor.get_data_ready_status`,Generator.ORDER_UNARY_POSTFIX]);
   
   }

    //% block="Read the data once and save it and get the result" blockType="command"
    export function readdata(parameter: any, block: any) { 
        
        Generator.addCode(`scd4x_CO2ppm, scd4x_temp, scd4x_humidity= scd4xSensor.read_measurement`);
   
   }

    //% block="Fetch [DAT] data from result" blockType="reporter"
    //% DAT.shadow="dropdown"   DAT.options="DAT"
    export function getdata(parameter: any, block: any) { 
        let dat = parameter.DAT.code;
        Generator.addCode( [`${dat}`,Generator.ORDER_UNARY_POSTFIX]);
   
   } 
}